  using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            {

                CategoryBuilder.Create("Zombie NPC Pack", "This mod adds zombies", ModAPI.LoadSprite("category_icon.png"));

                #region Zombie
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Zombie- ZNP",
                        DescriptionOverride = "Zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Zombie/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Zombie/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                            }


                            //----------------------------------------------------------------------------------------------------------------------------
                        }

                    }
                );
                #endregion


                #region Half Zombie
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Half Zombie- ZNP",
                        DescriptionOverride = "Half zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Half Zombie/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Half Zombie/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                            }


                            //----------------------------------------------------------------------------------------------------------------------------
                        }

                    }
                );
                #endregion


                #region Damaged Zombie
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Damaged Zombie- ZNP",
                        DescriptionOverride = "Damaged zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Damaged Zombie/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Damaged Zombie/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                            }


                            //----------------------------------------------------------------------------------------------------------------------------
                        }

                    }
                );
                #endregion


                #region Very Damaged Zombie
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Very Damaged Zombie- ZNP",
                        DescriptionOverride = "Very damaged zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Very Damaged Zombie/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Very Damaged Zombie/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                            }


                            //----------------------------------------------------------------------------------------------------------------------------
                        }

                    }
                );
                #endregion


                #region Extremly Damaged Zombie
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Extremly Damaged Zombie- ZNP",
                        DescriptionOverride = "Extremly damaged zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Extremly Damaged Zombie/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Extremly Damaged Zombie/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {
                                //----------------------------------------------------------------------------------------------------------------------------
                            }
                        }

                    }
                );
                #endregion


                #region Bonney
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Bonney- ZNP",
                        DescriptionOverride = "A really skinny zombie.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Bonney/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Bonney/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {
                                //----------------------------------------------------------------------------------------------------------------------------
                            }
                        }

                    }
                );
                #endregion


                #region Face Tearer
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Face Tearer- ZNP",
                        DescriptionOverride = "Zombie that tears faces",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Face Tearer/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Face Tearer/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {
                                //----------------------------------------------------------------------------------------------------------------------------
                            }
                        }

                    }
                );
                #endregion


                #region Zombie Prisoner
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Zombie Prisoner- ZNP",
                        DescriptionOverride = "They still do crimes.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Zombie Prisoner/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Zombie Prisoner/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {
                                //----------------------------------------------------------------------------------------------------------------------------
                            }
                        }

                    }
                );
                #endregion


                #region Zombie Military Unit
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Zombie Military Unit- ZNP",
                        DescriptionOverride = "They won't protect you anymore.",
                        CategoryOverride = ModAPI.FindCategory("Zombie NPC Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("Characters/Zombie Military Unit/Icon/icon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("Characters/Zombie Military Unit/base.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(45, 21, 21); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(45, 21, 21); //second bruise colour. red by default
                            person.SetThirdBruiseColor(45, 21, 21); // third bruise colour. light yellow by default
                            person.SetRottenColour(43, 43, 39); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(45, 21, 21); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {
                                //----------------------------------------------------------------------------------------------------------------------------
                            }
                        }

                    }
                );
                #endregion
                

            }
        }
    }
}